#define ORBITSTARTTIME 10258
#define ORBITENDTIME 10259
#define DEF_ALPHAF       4.000F
#define DEF_BETAF        0.100F  
#define DEF_GAMMAF       0.250F
#define DEF_DELTAF       2.000F
#define DEF_MIRAFTOG     0.1000F
#define DEF_MIRAFTIG     0.1500F
#define DEF_TATOG       -5.0F
#define DEF_TATIG       10.0F
#define DEF_ROGT         0.050F
#define ALPHAFLUN           209934
#define BETAFLUN            209935
#define MIRAFTOGLUN         209936
#define MIRAFTIGLUN         209937
#define TATOGLUN            209938
#define TATIGLUN            209939
#define ROGTLUN             209940
#define GAMMAFLUN           209944
#define DELTAFLUN           209945

#ifdef SUBSET
#define NCEPH2OLUN          209946
#define T2MLUN              209947
#define DEF_NCEPH2O         1.00000F
#define DEF_T2M             300.000F
#endif

/* Other Tables */

#define FOSTAB1 209520
#define FOSTAB1V 1

#define FOSTAB2 209521
#define FOSTAB2V 1

#define FOSTAB3 209522
#define FOSTAB3V 1

#define FOSTAB4 209523
#define FOSTAB4V 1

#define FOSTAB5 209524
#define FOSTAB5V 1

#define FOSTAB6 209525
#define FOSTAB6V 1

#define FOSTAB7 209526
#define FOSTAB7V 1

#define TA_TABLE1 209527
#define TA_TABLE1V 1

#define TA_TABLE2 209528
#define TA_TABLE2V 1

#define TA_TABLE3 209529
#define TA_TABLE3V 1

#define TA_TABLE4 209530
#define TA_TABLE4V 1

#define TA_TABLE5 209531
#define TA_TABLE5V 1

#define TA_TABLE6 209532
#define TA_TABLE6V 1

#define TA_TABLE7 209533
#define TA_TABLE7V 1

#define SRA 209534
#define SRAV 1

#define POLARIZATION_TABLE_LUN   209570  /*  --> new_modis_pol_corr5a.hdf    */
#define POLARIZATION_TABLE_LUN2  209569  /*  --> new_modis_pol_corr5b.hdf    */
#define RAYLEIGH_TABLE_LUN       209571  /*  --> rayleigh_modis_412_iqu3.hdf */



/* Run time parameters */
#define SATELLITEINSTRUMENTLUN 800510     /* 03-AUG-00 */
#define MOD09_ADJACENCY        209600
#define MOD09_BRDF             209601
#define MOD09_LAM              209602
#define MOD09_DEBUGLINE        209604   /* New, 25-MAR-99 */
#define MOD09_DEBUGPIX         209605    /* New, 25-MAR-99 */
#define MOD09_COARSE           209916
#define MOD09_FIRE             209917
#define PROCESS_SEA            209918
#define MOD09_BANDSEQSTART     209900
#define SCANS_PER_GRAN         209930
#define ATOOLLUN               209710
#define ATOOLFNAME             209711
#define ATOOLSPOT              209712
#define ATOOLSCAN              209713
#define MAKECLDSHD             209931
#define USEMODAOT              209933

#define BRDF_NONE 0
#define BRDF_MONTANA 1
#define BRDF_BOSTON 2

/* 19-DEC-01: limits of scan line processing (at SCF) */
#define SCFSTARTSCANLUN 209941
#define SCFENDSCANLUN 209942

/* Added 03-DEC-01: these (LINUX, IRIS4, HPUX) are defined at compile-time,
   in the makefile.  But the ideas of 13-FEB-02 (to take platform info
   from LUN 800550 in the PCF, which will come from 'uname -a') makes this 
   superfluous.  Will keep as backup/sanity check.  */
#if defined LINUX
#define PLATFORM "LINUX"
#elif defined IRIS4
#define PLATFORM "IRIS4"
#elif defined HPUX
#define PLATFORM "HPUX"
#else
#define PLATFORM "unknown"
#endif

/* 13-FEB-02 */
#define PLATFORMLUN 800550

/* 27-FEB-02 */
#define MAKECMGLUN  209943

