/*
!C-INC*****************************************************************************
!Description:

!Input Parameters:  N/A

!Output Parameters:  N/A


!Revision History:

Original version
J. Ray (jim@cratmos.gsfc.nasa.gov), SSAI: 04-APR-01

!Team-unique Header:

MODIS TEAM MEMBER, Christopher O. Justice justice@kratmos.gsfc.nasa.gov, 301-286-7372
		   NASA/GSFC Code 923
		   Greenbelt, MD , 20771

DEVELOPERS:  Eric F Vermote, eric@kratmos.gsfc.nasa.gov, 301-286-6232
	     Robert Wolfe,   rwolfwe@kratmos.gsfc.nasa.gov, 301-286-4585
	     Jeff Privette,  privette@kratmos.gsfc.nasa.gov, 301-286-5340
	     Nazmi El Saleous,  nazmi@kratmos.gsfc.nasa.gov, 301-286-0758

!References and Credits

!Design Notes

      To be "#include"'d in  polarization.c, and pol_global.h.
      
!END***************************************************************************
*/
#define MAX_POL_DIMS 4
typedef struct {
   char name[100];
   int dims[MAX_POL_DIMS];
   float *one_d_data;
   float ****data;
} pol_param_t;
